/*
 * Kernel - Points
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */

#include "kernel/internal.h"

#define GO_ID POINT
#define GO_SUBID POINT

PROP_INVISIBLE
PROP_ALL_REHANG(coordinate, PSTRUCT(invisible), geom.point, 0, "Hanger of point must be a mouse click to change position.", 0)
PROP_VIRTUAL(PROP_INVISIBLE_INIT, &PSTRUCT(coordinate_x), string_coordinate_x->text, &PSTRUCT(coordinate_y), string_coordinate_y->text)

INFO_ANCHOR_1("point", QT_POINT, LT_AFFINITY)
INFO_HANGER_1("point", QT_POINT, geom.point, NULL, LT_AFFINITY)
INFO_GO_1("point",
		POINT, "point", 1, -1, -1, -1, 0, 1, -1, -1, coordinate_x)

void go_point_recompute(struct go_point *p, struct geom_rectangle *bbox)
{
	p->geom.point = hanger_get_position(p->a->h);
	*bbox = (struct geom_rectangle){ p->geom.point, p->geom.point };
//	geom_point_after_change(&p->go); // not defined
}

void go_point_transform(struct go_point *p, struct geom_transform *t UNUSED, struct geom_rectangle *bbox)
{
	go_point_recompute(p, bbox);
}

struct go_point *go_point_new(struct hanger *h)
{
	struct go_point *p = xmalloc_zero(sizeof(struct go_point));
	go_init(&p->go, GOT_POINT, GOST_POINT, h);
	p->unit_coordinate_x = p->unit_coordinate_y = PROP_UNIT_MAX;
	return p;
}

