/** @file
 *
 * 	VRR kernel - Main header.
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */

#ifndef _KERNEL_KERNEL_H_
#define _KERNEL_KERNEL_H_

#include "lib/lib.h"
#include <setjmp.h>
#include <limits.h>
#include "lib/slists.h"
#include "lib/clists.h"
#include "lib/flists.h"
#include "geomlib/geomlib.h"

#include "scheme/scheme_def.h"

#include "kernel/strings.h"
#include "kernel/const.h"
#include "kernel/types.h"
#include "kernel/trans.h"
#include "kernel/property.h"
#include "kernel/plugin.h"

#ifndef DEBUG_REF_O
#define DEBUG_REF_O_ARGS
#else
#define DEBUG_REF_O_ARGS DEBUG_ARGS
#endif

#include "kernel/object.h"
#include "kernel/functions.h"
#include "kernel/tsort.h"
#include "kernel/go.h"
#include "kernel/geom.h"
#include "kernel/rtree.h"


#ifdef DEBUG_REF_O
#define obj_ref(s) obj_ref(s, __FILE__, __LINE__, __func__)
#define obj_unref(s) obj_unref(s, __FILE__, __LINE__, __func__)
#define go_ref(s) go_ref(s, __FILE__, __LINE__, __func__)
#define go_unref(s) go_unref(s, __FILE__, __LINE__, __func__)
#define o_ref(s) o_ref(s, __FILE__, __LINE__, __func__)
#define o_unref(s) o_unref(s, __FILE__, __LINE__, __func__)
#define hanger_ref(s) hanger_ref(s, __FILE__, __LINE__, __func__)
#define hanger_unref(s) hanger_unref(s, __FILE__, __LINE__, __func__)
#endif

void kernel_init(int argc, char **argv, uns gui, void (*start)(int argc, char **argv));
void kernel_finish(void);

#endif
