
;;; Trash


(define (make-doc name)
  (trans-main universe
	      (lambda ()
		(let ((doc (doc-new-named name)))
		  (obj-link-tail doc universe)
		  doc))))

(define (make-tlo doc name)
  (trans-main universe
	      (lambda ()
		(let ((tlo (tlo-new-named name)))
		  (obj-link-tail tlo doc)
		  tlo))
	      (lambda x x)
	      "Making tlo"))

(define pi (angle -1))

(define (cochline p1 p2 dpt)
  (if (= dpt 0)
      (make-segment (coords-c p1) (coords-c p2))
      (let* ((delta (/ (- p2 p1) 3))
	     (pn1 (+ p1 delta))
	     (pn2 (+ pn1 (make-polar (magnitude delta) (+ (angle delta) (/ pi 3)))))
	     (pn3 (+ pn1 delta))
	     (nd (- dpt 1)))
	(cochline p1 pn1 nd)
	(cochline pn1 pn2 nd)
	(cochline pn2 pn3 nd)
	(cochline pn3 p2 nd))))

(define (coch x1 y1 x2 y2 x3 y3 dpt)
  (cochline (make-rectangular x1 y1) (make-rectangular x2 y2) dpt)
  (cochline (make-rectangular x2 y2) (make-rectangular x3 y3) dpt)
  (cochline (make-rectangular x3 y3) (make-rectangular x1 y1) dpt))

(define (avg a b) (/ (+ a b) 2))
(define (ravg a b) (let ((p (+ 0.25 (/ (random 20) 40)))) (+ (* p a) (* (- 1 p) b))))

(define (tree x y d d1 d2 l b i)
  (define (treeline p d l i)
    (make-segment (coords-c p) (coords-c (+ p (make-polar l d))))
    (if (> i 0)
	(let ((i2 (- i 1)))
	  (treeline (+ p (make-polar (* (+ 0.6 (/ (random 10) 50)) l) d))
		    (ravg d d1) (* l (+ (/ (random 10) 30) 0.5)) i2)
	  (treeline (+ p (make-polar (* (+ 0.6 (/ (random 10) 50)) l) d))
		    (ravg d d2) (* l (+ (/ (random 10) 30) 0.5)) i2))))
  (for-each (lambda (none)
	      (treeline (make-rectangular x y) d l i))
	    (iota b)))

					; example (trans-main (lookup "Page 1") (lambda () (tree-final 0 0 20 6 2)))
(define (tree-final x y length iterations density)
  (tree x y (/ pi 2) 0 pi length density iterations))

					;(trans-main tlo (lambda () (coch -2 -2 0 2 2 -2 3)))
					;
					;(trans-main tlo (lambda () (let ((circ (go_arc_new_3points 0 "0x8260778" "0x825f5a0" "0x825b8f0"))) (go-link circ))))

					;(trans-main (lookup "Page 1") (lambda () (coch -40 -40 0 40 40 -40 4)))
					;(tst-quadratic -2 -2 1 0 2 1  2 -1 1)

(define (go-remove-all tlo)
  (trans-main tlo
	      (lambda () (tlo-remove-relink-selected-go))
	      (lambda () ())
	      "Unlinking all go"))

(define (go-remove go)
  (trans-main (go-get-tlo go)
	      (lambda () (go-remove-relink go))
	      (lambda () ())
	      "Unlinking go"))

(define (make-mc tlo x y)
  (trans-main tlo
	      (lambda () (mc-new x y))
	      (lambda () ())
	      "Making mouse click"))

(define (rnd) (- (/ (random 8000) 100)  40))

(define (click x y)
  (trans-main (lookup "Page 1") (lambda () (mc-new x y))))

(define (make func . args)
  (trans-main (lookup "Page 1") (lambda ()
				  (go-link-after (apply func args)))))

(define (vlocka)
  (trans-main (lookup "Page 1") (lambda () (coch -20 -20 0 20 50 -20 3))))

(define (clear-undo)
  (define (cu obj)
    (if (proxy? obj (string->symbol "obj") (string->symbol "tlo")) (trans-clear-undo obj 0))
    (if (obj-recurse-next universe obj) (cu (obj-recurse-next universe obj))))
  (trans-clear-undo universe 0)
  (cu universe))

(define (clipboard-paste tlo) (trans-main tlo (lambda () (tlo-clipboard-paste))))

(define (clipboard-cut tlo) (trans-main tlo (lambda () (tlo-clipboard-cut))))

(define (copy-paste-test)
  (Kn2 (lookup "Page 1") 5)
  (trans-main (lookup "Page 1") (lambda ()
				  (go-select (lookup "segment-0-1"))
				  (go-select (lookup "segment-1-2"))
				  (go-select (lookup "segment-2-3"))
				  (go-select (lookup "segment-3-4"))
				  ))
  (clipboard-copy (lookup "Page 1"))
  (clipboard-paste (lookup "Page 2"))
  )

(define (cut-paste-test)
  (Kn2 (lookup "Page 1") 5)
  (trans-main (lookup "Page 1") (lambda ()
				  (go-select (lookup "segment-0-1"))
				  (go-select (lookup "segment-1-2"))
				  (go-select (lookup "segment-2-3"))
				  (go-select (lookup "segment-3-4"))
				  ))
  (clipboard-cut (lookup "Page 1"))
  (clipboard-paste (lookup "Page 2"))
  )

