#ifndef _VCL_AFFINITY_H_
#define _VCL_AFFINITY_H_

/**@file
 *
 * VCL module header
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */



extern vcl_vtable *vcl_vt_affinity;

struct vcl_affinity
{
  struct vcl_object header;
  struct geom_transform2 coords;
  struct geom_rectangle bbox;

  void * child;
  void * parent;
  int data;
};


static inline uns
vcl_affinity_p (void *obj)
{ return (VCL_CLASS_P (obj, vcl_vt_affinity)); }

extern struct vcl_affinity *
vcl_affinity_new (void);

static inline struct geom_transform2 *
vcl_affinity_get (struct vcl_affinity *obj)
{ return (&(obj -> coords)); }

extern void
vcl_affinity_set (struct vcl_affinity *obj, const struct geom_transform2 *t);

extern void
vcl_affinity_inner_merge (struct vcl_affinity *obj, const struct geom_transform2 *t);

extern void
vcl_affinity_outer_merge (struct vcl_affinity *obj, const struct geom_transform2 *t);

static inline void
vcl_affinity_merge (struct vcl_affinity *obj, struct geom_transform2 *t)
{ vcl_affinity_outer_merge (obj, t); }


#ifdef _VCL_INTERNAL_


extern void
vcl_affinity_main (void);


#endif
#endif
