#ifndef _VCL_CANVAS_H_
#define _VCL_CANVAS_H_

/**@file
 *
 * VCL module header
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */


vcl_vtable *vcl_vt_canvas;

#define VCL_CANVAS_REAL_UNITS  1
#define VCL_CANVAS_FULL_WIDTH  2
#define VCL_CANVAS_FLIP_X      4
#define VCL_CANVAS_FLIP_Y      8
#define VCL_CANVAS_REALIZED   16

#define VCL_CANVAS_USER_FLAGS 15


struct vcl_gtk_canvas;

struct vcl_canvas
{
  struct vcl_object header;
  struct vcl_gtk_canvas *gtk;
  int win_w, win_h;
  real center_x, center_y;
  real unit_scale_x, unit_scale_y, unit_size;
  void *painter;
  void *root;
  int flags;
};

struct vcl_gtk_canvas
{
  GtkWidget *widget;
  struct vcl_canvas data;
};


static inline uns
vcl_canvas_p (void *obj)
{ return (VCL_CLASS_P (obj, vcl_vt_canvas)); }

extern void
vcl_canvas_setup (struct vcl_canvas *obj, int flags,
		  real center_x, real center_y, real unit_size);

static inline void
vcl_canvas_set_root (struct vcl_canvas *obj, void * root)
{ vcl_enclosure_set_child (obj -> root, root); }

static inline void *
vcl_canvas_get_root (struct vcl_canvas *obj)
{ return (vcl_enclosure_get_child (obj -> root)); }


extern struct vcl_canvas *
vcl_canvas_new (void);


#ifdef _VCL_INTERNAL_


extern void
vcl_canvas_main (void);


#endif
#endif
