#ifndef _VCL_IF_PAINTER_H_
#define _VCL_IF_PAINTER_H_

/**@file
 *
 * VCL module header
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */



extern int vcl_if_painter;

extern int vcl_mid_painter_draw_begin;
extern int vcl_mid_painter_draw_end;
extern int vcl_mid_painter_draw_node;
extern int vcl_mid_painter_draw_leaf;
extern int vcl_mid_painter_draw_composite;

static inline uns
vcl_if_painter_p (void *obj)
{ return (vcl_class_supports_interface_p (VCL_GET_CLASS (obj), vcl_if_painter)); }

/* if node supports interface transformation, then it is valid to put NULL as bbox_local */
static inline void
vcl_painter_draw_begin (void * obj, const struct vcl_rectangle *bbox)
{ VCL_METHOD (int, vcl_mid_painter_draw_begin, bbox); }

static inline void
vcl_painter_draw_end (void * obj)
{ VCL_METHOD (int, vcl_mid_painter_draw_end); }

static inline void
vcl_painter_draw_node (void * obj, void * node, const struct vcl_rectangle *bbox, const struct geom_rectangle *bbox_local)
{ VCL_METHOD (int, vcl_mid_painter_draw_node, node, bbox, bbox_local); }

static inline void
vcl_painter_draw_leaf (void * obj, void * node, const struct vcl_rectangle *bbox, const struct geom_rectangle *bbox_local)
{ VCL_METHOD (int, vcl_mid_painter_draw_leaf, node, bbox, bbox_local); }

static inline void
vcl_painter_draw_composite (void * obj, void * node, const struct vcl_rectangle *bbox, const struct geom_rectangle *bbox_local)
{ VCL_METHOD (int, vcl_mid_painter_draw_composite, node, bbox, bbox_local); }


#ifdef _VCL_INTERNAL_


extern void
vcl_if_painter_main (void);


#endif
#endif
