#ifndef _VCL_IF_TRANSFORMATION_H_
#define _VCL_IF_TRANSFORMATION_H_

/**@file
 *
 * VCL module header
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */



extern int vcl_if_transformation;

extern int vcl_mid_transformation_primary_apply_matrix;
extern int vcl_mid_transformation_inverted_apply_matrix;
extern int vcl_mid_transformation_primary_preply_matrix;
extern int vcl_mid_transformation_inverted_preply_matrix;
extern int vcl_mid_transformation_primary_apply_point;
extern int vcl_mid_transformation_inverted_apply_point;


static inline uns
vcl_if_transformation_p (void *obj)
{ return (vcl_class_supports_interface_p (VCL_GET_CLASS (obj), vcl_if_transformation)); }

static inline int
vcl_transformation_primary_apply_matrix (void * obj, const struct geom_transform *src, struct geom_transform *dst)
{ return (VCL_METHOD (int, vcl_mid_transformation_primary_apply_matrix, src, dst)); }

static inline int
vcl_transformation_inverted_apply_matrix (void * obj, const struct geom_transform *src, struct geom_transform *dst)
{ return (VCL_METHOD (int, vcl_mid_transformation_inverted_apply_matrix, src, dst)); }

static inline int
vcl_transformation_primary_preply_matrix (void * obj, const struct geom_transform *src, struct geom_transform *dst)
{ return (VCL_METHOD (int, vcl_mid_transformation_primary_preply_matrix, src, dst)); }

static inline int
vcl_transformation_inverted_preply_matrix (void * obj, const struct geom_transform *src, struct geom_transform *dst)
{ return (VCL_METHOD (int, vcl_mid_transformation_inverted_preply_matrix, src, dst)); }


static inline int
vcl_transformation_primary_apply_point (void * obj, const struct geom_point *src, struct geom_point *dst)
{ return (VCL_METHOD (int, vcl_mid_transformation_primary_apply_point, src, dst)); }

static inline int
vcl_transformation_inverted_apply_point (void * obj, const struct geom_point *src, struct geom_point *dst)
{ return (VCL_METHOD (int, vcl_mid_transformation_inverted_apply_point, src, dst)); }


#ifdef _VCL_INTERNAL_


extern void
vcl_if_transformation_main (void);


#endif
#endif
