#ifndef _VCL_PROPERTY_H_
#define _VCL_PROPERTY_H_

/**@file
 *
 * VCL module header
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */



extern vcl_vtable *vcl_vt_property;


struct vcl_property
{
  struct vcl_object header;
  struct vcl_growing_array values;
  struct vcl_growing_array control;

  real enlargement;
  void * child;
  void * parent;
  int data;
};


static inline uns
vcl_property_p (void *obj)
{ return (VCL_CLASS_P (obj, vcl_vt_property)); }

extern struct vcl_property *
vcl_property_new (void);

extern void
vcl_property_set (struct vcl_property * obj, int prop_id, void *prop_data);

extern int
vcl_property_get_count (struct vcl_property * obj);

extern int
vcl_property_get_nth_type (struct vcl_property * obj, int n);

extern void *
vcl_property_get_nth_value (struct vcl_property * obj, int n);

extern void *
vcl_property_get (struct vcl_property * obj, int prop_id);

extern void
vcl_property_changed (struct vcl_property * obj);

extern void
vcl_property_set_stroke_width (struct vcl_property * obj, double width);

static inline void
vcl_property_set_fill_color (void  *prop, u32 color)
{ 
  vcl_property_set (prop, VCL_PROP_FILL_COLOR, &color);
  vcl_property_changed (prop);
}

static inline void
vcl_property_set_stroke_color (void  *prop, u32 color)
{
  vcl_property_set (prop, VCL_PROP_STROKE_COLOR, &color); 
  vcl_property_changed (prop);
}

static inline void
vcl_property_set_stroke_dot_style (void  *prop, uns dot_style)
{
  vcl_property_set (prop, VCL_PROP_STROKE_DOT_STYLE, &dot_style);
  vcl_property_changed (prop);
}

static inline void
vcl_property_set_stroke_cap_style (void  *prop, uns cap_style)
{
  vcl_property_set (prop, VCL_PROP_STROKE_CAP_STYLE, &cap_style);
  vcl_property_changed (prop);
}

static inline void
vcl_property_set_stroke_join_style (void  *prop, uns join_style)
{
  vcl_property_set (prop, VCL_PROP_STROKE_JOIN_STYLE, &join_style);
  vcl_property_changed (prop);
}


#ifdef _VCL_INTERNAL_


extern void
vcl_property_main (void);


#endif
#endif
